<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrapper">
            <ListPage :desktop="4" :mobile="12" class="q-pa-lg">
                <Form @success="SubmitSuccess" :on-submit="Submit"
                      :fields="fields" v-model="model" title="Create SubContractor">
                    <template #nameAppend>
                        <div class="col-3">
                            <div class="row justify-end">
                                <AvatarPicker v-model="image" title="Choose Subcontractor Logo"/>
                            </div>
                        </div>
                    </template>
                </Form>
            </ListPage>
        </DocumentWrapper>

    </q-page>
</template>

<style lang='scss' scoped>
.body--light {
    .image-uploader {
        background: #FFF;
    }
}

.body--dark {
    .image-uploader {
        background: $dark;
    }

    .dark-fab {
        background: #232323;
    }
}
</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import Form from "components/Form.vue";
import LabelSlot from "components/LabelSlot.vue";
import ImageUploader from "components/Core/ImageUploader.vue";
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {SubContractorResponse} from "src/classLibrary/APIModels/core/subContractorResponse";
import ColorPicker from "components/Core/ColorPicker.vue";
import AvatarPicker from "components/Core/AvatarPicker.vue";
import ColorInput from "components/Core/ColorInput.vue";
import ListPage from "components/Core/ListPage.vue";
import {FormInput} from "src/classLibrary/FormTypes";

@Component({
    components: {ListPage, ColorInput, AvatarPicker, ColorPicker, DocumentWrapper, ImageUploader, LabelSlot, Form}
})
export default class CreateSubContractor extends Vue {

    get Form(): Form {
        return this.$refs.form as any;
    }

    async Submit(_: any) {
        const token = await this.$auth.CoreToken;
        const i = this.image === '' ? GenerateAvatar(this.model.models.name) : this.image;
        return this.$coreApi.Post<SubContractorResponse>(`SubContractor/${this.PersistentStore.StoreValue.project}`, {
            name: this.model.models.name,
            color: this.model.models.color,
            logo: i,
            data: {}
        }, token);
    }

    async SubmitSuccess(a: SubContractorResponse) {
        this.$q.notify({
            color: 'positive',
            message: `Successfully created subcontractor ${a.principal.name}`,
            icon: 'check'
        });
        await this.$router.push("/subcontractor");
    }

    image = '';

    model = {
        valid: false,
        models: {
            name: '',
            color: ''
        }
    }

    fields: FormInput[] = [
        {
            rules: [
                (v: string) => !!v || 'Please enter the SubContractor name',
                (v: string) => (v.length < 128 && v.length > 1) || 'SubContractor name has to be between 2 to 128 characters',
            ],
            label: 'SubContractor Name',
            tooltip: "Name of the SubContractor",
            icon: 'business',
            key: 'name',
            max: 128,
            baseType: 'basic',
            type: 'text'
        },
        {
            rules: [
                (v: string) => !!v || 'Please choose a color to present your Subcontractor',
            ],
            label: 'Color',
            tooltip: "A color for your subcontractor. This color is used for live-view and graphs",
            icon: 'colorize',
            key: 'color',
            baseType: 'color',
        },
    ]

    // otherFields: string[] = []
    // fields: Input[] = [
    //     {
    //         rules: [
    //             (v: string) => !!v || 'Please enter the SubContractor name',
    //             (v: string) => (v.length < 128 && v.length > 1) || 'SubContractor name has to be between 2 to 128 characters',
    //         ],
    //         label: 'SubContractor Name',
    //         tooltip: "Name of the SubContractor",
    //         icon: 'business',
    //         key: 'name',
    //         max: 128,
    //     },
    //     // {
    //     //     key: 'color',
    //     //     rules: [
    //     //         (v: string) => !!v || 'Please choose a color to present your Subcontractor',
    //     //         (v: string) => tinycolor(v).isValid() || 'Invalid color',
    //     //     ],
    //     //     autoGrow: true,
    //     //     label: 'Color',
    //     //     tooltip: "A color for your subcontractor. This color is used for live-view and graphs",
    //     //     icon: 'colorize',
    //     // }
    // ]

}
</script>
